/*
 * TismTool © Tis Veugen, 2010-2012
 * Simulation, Verification
 *
 * TsmASPort.h
 * version 3
 */
#ifndef TSM_ASPORT_H
#define TSM_ASPORT_H

#include "TsmActivePort.h"
#include "TsmTrigger.h"
#include "TsmEnvelope.h"
#include "TsmThread.h"
using namespace std;

namespace TsmRTE
{
  /**
   * Active Server Port
   */
  class TsmASPort : public TsmActivePort
  {
  public:
    bool Handle( TsmTrigger* oTrigger )
    {
      TsmEnvelope lEnvelope( oTrigger, Target );
      mThread->SyncCall( lEnvelope );
      return true;
    }

    string ToSeq()
    {
      stringstream sb;
      sb << "R," << mThread->getExtQueue()->getSeqId();
      return sb.str();
    }
  };
}
#endif
